# coding: utf-8
try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from cloudtower.configuration import Configuration


class ApplicationVmSpecNetwork(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'nics': 'list[ApplicationVmSpecNic]',
        'dns': 'list[str]'
    }

    attribute_map = {
        'nics': 'nics',
        'dns': 'dns'
    }

    def __init__(self, **kwargs):  # noqa: E501
        """ApplicationVmSpecNetwork - a model defined in OpenAPI"""  # noqa: E501
        self.local_vars_configuration = kwargs.get("local_vars_configuration", Configuration.get_default_copy())

        self._nics = None
        self._dns = None
        self.discriminator = None

        if "nics" in kwargs:
            self.nics = kwargs["nics"]
        if "dns" in kwargs:
            self.dns = kwargs["dns"]

    @property
    def nics(self):
        """Gets the nics of this ApplicationVmSpecNetwork.  # noqa: E501


        :return: The nics of this ApplicationVmSpecNetwork.  # noqa: E501
        :rtype: list[ApplicationVmSpecNic]
        """
        return self._nics

    @nics.setter
    def nics(self, nics):
        """Sets the nics of this ApplicationVmSpecNetwork.


        :param nics: The nics of this ApplicationVmSpecNetwork.  # noqa: E501
        :type nics: list[ApplicationVmSpecNic]
        """

        self._nics = nics

    @property
    def dns(self):
        """Gets the dns of this ApplicationVmSpecNetwork.  # noqa: E501


        :return: The dns of this ApplicationVmSpecNetwork.  # noqa: E501
        :rtype: list[str]
        """
        return self._dns

    @dns.setter
    def dns(self, dns):
        """Sets the dns of this ApplicationVmSpecNetwork.


        :param dns: The dns of this ApplicationVmSpecNetwork.  # noqa: E501
        :type dns: list[str]
        """

        self._dns = dns

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApplicationVmSpecNetwork):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ApplicationVmSpecNetwork):
            return True

        return self.to_dict() != other.to_dict()
