# coding: utf-8
try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from cloudtower.configuration import Configuration


class GpuDeviceOrderByInput(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    allowed enum values
    """
    ASSIGNED_VGPUS_NUM_ASC = "assigned_vgpus_num_ASC"
    ASSIGNED_VGPUS_NUM_DESC = "assigned_vgpus_num_DESC"
    AVAILABLE_VGPUS_NUM_ASC = "available_vgpus_num_ASC"
    AVAILABLE_VGPUS_NUM_DESC = "available_vgpus_num_DESC"
    BRAND_ASC = "brand_ASC"
    BRAND_DESC = "brand_DESC"
    BUS_LOCATION_ASC = "bus_location_ASC"
    BUS_LOCATION_DESC = "bus_location_DESC"
    DESCRIPTION_ASC = "description_ASC"
    DESCRIPTION_DESC = "description_DESC"
    DRIVER_INFO_ASC = "driver_info_ASC"
    DRIVER_INFO_DESC = "driver_info_DESC"
    ENTITYASYNCSTATUS_ASC = "entityAsyncStatus_ASC"
    ENTITYASYNCSTATUS_DESC = "entityAsyncStatus_DESC"
    ID_ASC = "id_ASC"
    ID_DESC = "id_DESC"
    IS_NVIDIA_TOOLS_READY_ASC = "is_nvidia_tools_ready_ASC"
    IS_NVIDIA_TOOLS_READY_DESC = "is_nvidia_tools_ready_DESC"
    IS_NVIDIA_VFS_ENABLED_ASC = "is_nvidia_vfs_enabled_ASC"
    IS_NVIDIA_VFS_ENABLED_DESC = "is_nvidia_vfs_enabled_DESC"
    IS_NVIDIA_VFS_SUPPORTED_ASC = "is_nvidia_vfs_supported_ASC"
    IS_NVIDIA_VFS_SUPPORTED_DESC = "is_nvidia_vfs_supported_DESC"
    LOCAL_CREATED_AT_ASC = "local_created_at_ASC"
    LOCAL_CREATED_AT_DESC = "local_created_at_DESC"
    LOCAL_ID_ASC = "local_id_ASC"
    LOCAL_ID_DESC = "local_id_DESC"
    MDEV_SUPPORTED_TYPES_ASC = "mdev_supported_types_ASC"
    MDEV_SUPPORTED_TYPES_DESC = "mdev_supported_types_DESC"
    MODEL_ASC = "model_ASC"
    MODEL_DESC = "model_DESC"
    NAME_ASC = "name_ASC"
    NAME_DESC = "name_DESC"
    STATUS_ASC = "status_ASC"
    STATUS_DESC = "status_DESC"
    USER_USAGE_ASC = "user_usage_ASC"
    USER_USAGE_DESC = "user_usage_DESC"
    USER_VGPU_TYPE_ID_ASC = "user_vgpu_type_id_ASC"
    USER_VGPU_TYPE_ID_DESC = "user_vgpu_type_id_DESC"
    USER_VGPU_TYPE_NAME_ASC = "user_vgpu_type_name_ASC"
    USER_VGPU_TYPE_NAME_DESC = "user_vgpu_type_name_DESC"
    VGPU_INSTANCE_NUM_ASC = "vgpu_instance_num_ASC"
    VGPU_INSTANCE_NUM_DESC = "vgpu_instance_num_DESC"

    allowable_values = [ASSIGNED_VGPUS_NUM_ASC, ASSIGNED_VGPUS_NUM_DESC, AVAILABLE_VGPUS_NUM_ASC, AVAILABLE_VGPUS_NUM_DESC, BRAND_ASC, BRAND_DESC, BUS_LOCATION_ASC, BUS_LOCATION_DESC, DESCRIPTION_ASC, DESCRIPTION_DESC, DRIVER_INFO_ASC, DRIVER_INFO_DESC, ENTITYASYNCSTATUS_ASC, ENTITYASYNCSTATUS_DESC, ID_ASC, ID_DESC, IS_NVIDIA_TOOLS_READY_ASC, IS_NVIDIA_TOOLS_READY_DESC, IS_NVIDIA_VFS_ENABLED_ASC, IS_NVIDIA_VFS_ENABLED_DESC, IS_NVIDIA_VFS_SUPPORTED_ASC, IS_NVIDIA_VFS_SUPPORTED_DESC, LOCAL_CREATED_AT_ASC, LOCAL_CREATED_AT_DESC, LOCAL_ID_ASC, LOCAL_ID_DESC, MDEV_SUPPORTED_TYPES_ASC, MDEV_SUPPORTED_TYPES_DESC, MODEL_ASC, MODEL_DESC, NAME_ASC, NAME_DESC, STATUS_ASC, STATUS_DESC, USER_USAGE_ASC, USER_USAGE_DESC, USER_VGPU_TYPE_ID_ASC, USER_VGPU_TYPE_ID_DESC, USER_VGPU_TYPE_NAME_ASC, USER_VGPU_TYPE_NAME_DESC, VGPU_INSTANCE_NUM_ASC, VGPU_INSTANCE_NUM_DESC]  # noqa: E501

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
    }

    attribute_map = {
    }

    def __init__(self, **kwargs):  # noqa: E501
        """GpuDeviceOrderByInput - a model defined in OpenAPI"""  # noqa: E501
        self.local_vars_configuration = kwargs.get("local_vars_configuration", Configuration.get_default_copy())
        self.discriminator = None

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GpuDeviceOrderByInput):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GpuDeviceOrderByInput):
            return True

        return self.to_dict() != other.to_dict()
