# coding: utf-8
try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from cloudtower.configuration import Configuration


class UserRoleNext(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'actions': 'list[str]',
        'id': 'str',
        'name': 'str',
        'platform': 'UserRolePlatform',
        'preset': 'UserRolePreset',
        'users': 'list[NestedUser]'
    }

    attribute_map = {
        'actions': 'actions',
        'id': 'id',
        'name': 'name',
        'platform': 'platform',
        'preset': 'preset',
        'users': 'users'
    }

    def __init__(self, **kwargs):  # noqa: E501
        """UserRoleNext - a model defined in OpenAPI"""  # noqa: E501
        self.local_vars_configuration = kwargs.get("local_vars_configuration", Configuration.get_default_copy())

        self._actions = None
        self._id = None
        self._name = None
        self._platform = None
        self._preset = None
        self._users = None
        self.discriminator = None

        if "actions" in kwargs:
            self.actions = kwargs["actions"]
        if "id" in kwargs:
            self.id = kwargs["id"]
        if "name" in kwargs:
            self.name = kwargs["name"]
        if "platform" in kwargs:
            self.platform = kwargs["platform"]
        self.preset = kwargs.get("preset", None)
        self.users = kwargs.get("users", None)

    @property
    def actions(self):
        """Gets the actions of this UserRoleNext.  # noqa: E501


        :return: The actions of this UserRoleNext.  # noqa: E501
        :rtype: list[str]
        """
        return self._actions

    @actions.setter
    def actions(self, actions):
        """Sets the actions of this UserRoleNext.


        :param actions: The actions of this UserRoleNext.  # noqa: E501
        :type actions: list[str]
        """
        if self.local_vars_configuration.client_side_validation and actions is None:  # noqa: E501
            raise ValueError("Invalid value for `actions`, must not be `None`")  # noqa: E501

        self._actions = actions

    @property
    def id(self):
        """Gets the id of this UserRoleNext.  # noqa: E501


        :return: The id of this UserRoleNext.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this UserRoleNext.


        :param id: The id of this UserRoleNext.  # noqa: E501
        :type id: str
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this UserRoleNext.  # noqa: E501


        :return: The name of this UserRoleNext.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this UserRoleNext.


        :param name: The name of this UserRoleNext.  # noqa: E501
        :type name: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def platform(self):
        """Gets the platform of this UserRoleNext.  # noqa: E501


        :return: The platform of this UserRoleNext.  # noqa: E501
        :rtype: UserRolePlatform
        """
        return self._platform

    @platform.setter
    def platform(self, platform):
        """Sets the platform of this UserRoleNext.


        :param platform: The platform of this UserRoleNext.  # noqa: E501
        :type platform: UserRolePlatform
        """
        if self.local_vars_configuration.client_side_validation and platform is None:  # noqa: E501
            raise ValueError("Invalid value for `platform`, must not be `None`")  # noqa: E501

        self._platform = platform

    @property
    def preset(self):
        """Gets the preset of this UserRoleNext.  # noqa: E501


        :return: The preset of this UserRoleNext.  # noqa: E501
        :rtype: UserRolePreset
        """
        return self._preset

    @preset.setter
    def preset(self, preset):
        """Sets the preset of this UserRoleNext.


        :param preset: The preset of this UserRoleNext.  # noqa: E501
        :type preset: UserRolePreset
        """

        self._preset = preset

    @property
    def users(self):
        """Gets the users of this UserRoleNext.  # noqa: E501


        :return: The users of this UserRoleNext.  # noqa: E501
        :rtype: list[NestedUser]
        """
        return self._users

    @users.setter
    def users(self, users):
        """Sets the users of this UserRoleNext.


        :param users: The users of this UserRoleNext.  # noqa: E501
        :type users: list[NestedUser]
        """

        self._users = users

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserRoleNext):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UserRoleNext):
            return True

        return self.to_dict() != other.to_dict()
